#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"


char * get_username()
{
  return g_strdup(nuapp_datas.username);
}


char* get_password()
{
  return g_strdup(nuapp_datas.password);
}

    static gboolean 
call_nu_client(NuApp* nudatas)
{
  if (nuapp_datas.auth_on == TRUE){
      if (nuapp_datas.session){
          if (nu_client_check(nuapp_datas.session
#ifdef API_V2
                      ,NULL
#endif
                      )< 0){
              nuapp_datas.session = NULL;
              nuapp_datas.timeout=1000;
              nuapp_datas.timevalue=0;
          }
      } else {
          nuapp_datas.timevalue+=nuapp_datas.interval;
          if (nuapp_datas.timevalue >= nuapp_datas.timeout){
              nuapp_datas.session = nu_client_init2(
                      nuapp_datas.host,
                      nuapp_datas.port,
                      NULL,
                      NULL,
                      &get_username,
                      &get_password,
                      NULL
#ifdef API_V2
                      , NULL
#endif
                      );
              if (nuapp_datas.session == NULL){
                  if (nuapp_datas.timeout < RETRY_TIME_MAX)
                      nuapp_datas.timeout=2*nuapp_datas.timeout;
                  nuapp_datas.timevalue=0;
              }
          }
      }
  } else {
      if ( nuapp_datas.session ){
          nu_client_free(nuapp_datas.session
#ifdef API_V2
                  ,NULL
#endif
                  );
          nuapp_datas.session = NULL;
      }
  }
  return TRUE;
}



void start_auth()
{
  nuapp_datas.session = nu_client_init2(
                  nuapp_datas.host,
                  nuapp_datas.port,
                  NULL,
                  NULL,
                  &get_username,
                  &get_password,
                  NULL
#ifdef API_V2
                  ,
                  NULL
#endif
                  );

          if (nuapp_datas.session == NULL) {
              int nerror=errno;
              GtkWidget *info_dialog;
              char *string_error;
              if (nerror == EACCES){
                  string_error=_("Invalid Login/Password");
              } else 
                  string_error = strerror(nerror);
#if 0
              info_dialog = gnome_message_box_new (
                      g_strconcat (
                          _("Connection failed :"),
                          "\n",
                          string_error,
                          NULL),
                      GNOME_MESSAGE_BOX_ERROR,
                      "OK",
                      NULL);
              gnome_dialog_run (GNOME_DIALOG (info_dialog));
#endif
          } else {
              nuapp_datas.auth_on= TRUE;
              nuapp_datas.timer = g_timeout_add(nuapp_datas.interval,(GSourceFunc)call_nu_client,NULL);
              gtk_image_set_from_pixbuf(GTK_IMAGE (
                      lookup_widget((GtkWidget*)nuapp_datas.main_window,"nupik") 
                  ),
                  OnAirNupikImage);
              gtk_button_set_label(
                      GTK_BUTTON (
                      lookup_widget((GtkWidget*)nuapp_datas.main_window,"start_stop_button") 
                  ),
                      _("Stop")
                      );


#if 0
              gtk_image_set_from_stock (
                      GTK_IMAGE(nuapp_datas.image),
                      "nufw-active",
                      nuapp_datas.panel_size	
                      );
              gtk_tooltips_set_tip (nuapp_datas.tooltip,
                      nuapp_datas.event_box,
                      _("NuFW authentication active"),
                      _("Click right to inactivate"));
#endif
          }
      }

    void
on_quitter1_activate                   (GtkMenuItem     *menuitem,
        gpointer         user_data)
{

}


    void
on_pr__f__rences1_activate             (GtkMenuItem     *menuitem,
        gpointer         user_data)
{

}


    void
on____propos1_activate                 (GtkMenuItem     *menuitem,
        gpointer         user_data)
{

}

    void
on_start_stop_button_clicked           (GtkButton       *button,
        gpointer         user_data)
{
  if (nuapp_datas.auth_on == FALSE ){
#if 0
      if ( nuapp_datas.session ){
          nu_client_free(nuapp_datas.session);
          nuapp_datas.session = NULL;
      }
#endif
      if ((! nuapp_datas.username) || (! nuapp_datas.password)){
          GtkWidget* prompt;
          prompt = create_prompt_creds(); 
          gtk_widget_show(prompt);
      } else {
          start_auth();
      }
       
  } else {
      g_source_remove(nuapp_datas.timer);
      if (nuapp_datas.session){
          nu_client_free(nuapp_datas.session
#ifdef API_V2
                  ,NULL
#endif
                  );
          nuapp_datas.session=NULL;
          gtk_image_set_from_pixbuf(GTK_IMAGE
                  (
                      lookup_widget((GtkWidget*)nuapp_datas.main_window,"nupik") 
                  ),
                  NupikImage);
 gtk_button_set_label(
                      GTK_BUTTON (
                      lookup_widget((GtkWidget*)nuapp_datas.main_window,"start_stop_button") 
                  ),
                      _("Start")
                      );


          nuapp_datas.auth_on = FALSE; 
      }
#if 0
      gtk_image_set_from_stock (
              GTK_IMAGE(nuapp_datas.image),
              "nufw-inactive",
              nuapp_datas.panel_size	
              );
      gtk_tooltips_set_tip (nuapp_datas.tooltip,
              nuapp_datas.event_box,
              _("NuFW authentication inactive"),
              _("Click right to activate"));
#endif
  }


}


    void
on_applypref_clicked                   (GtkButton       *button,
        gpointer         user_data)
{

  /* host */
	nuapp_datas.host = g_strdup (gtk_entry_get_text(
                (GtkEntry*)
                lookup_widget((GtkWidget*)button,"pref_host")
                    )
				);
	/* user_entry */
    if (nuapp_datas.username){
        g_free(nuapp_datas.username);
    }
	nuapp_datas.username = g_strdup (gtk_entry_get_text(
                (GtkEntry*)
                lookup_widget((GtkWidget*)button,"pref_username")
                    )
				);

	nuapp_datas.port = gtk_spin_button_get_value_as_int (
		GTK_SPIN_BUTTON(lookup_widget((GtkWidget*)button,"pref_port"))
			);

	nuapp_datas.interval = gtk_spin_button_get_value_as_int (
            GTK_SPIN_BUTTON( lookup_widget((GtkWidget*)button,"pref_interval")));

	nuapp_datas.start_minimized = gtk_toggle_button_get_active (
            GTK_TOGGLE_BUTTON(
			lookup_widget((GtkWidget*)button,"pref_start_minimized")
            )
            );

	nuapp_datas.auth_at_start = gtk_toggle_button_get_active (
            GTK_TOGGLE_BUTTON(
			lookup_widget((GtkWidget*)button,"pref_auth_at_start")
            )
            );


  dump_nuauth_params_to_file(config_file);
}


    void
on_cancelpref_clicked                  (GtkButton       *button,
        gpointer         user_data)
{
  gtk_widget_destroy(lookup_widget((GtkWidget*)button,"prefs"));
}


    void
on_okpref_clicked                      (GtkButton       *button,
        gpointer         user_data)
{
  on_applypref_clicked (button,user_data);
  gtk_widget_destroy(lookup_widget((GtkWidget*)button,"prefs"));
}


    void
on_prefs_activate                      (GtkMenuItem     *menuitem,
        gpointer         user_data)
{
  GtkWidget *prefs;

  prefs = create_prefs ();
  gtk_widget_show (prefs);

}


    void
on_about_activate                      (GtkMenuItem     *menuitem,
        gpointer         user_data)
{
  GtkWidget *aboutdialog1;

  aboutdialog1 = create_aboutdialog1 ();
  gtk_widget_show (aboutdialog1);

}


    gboolean
on_main_window_destroy_event           (GtkWidget       *widget,
        GdkEvent        *event,
        gpointer         user_data)
{
  gtk_main_quit();
  return TRUE;
}


    void
on_okcreds_clicked                     (GtkButton       *button,
        gpointer         user_data)
{
  gchar * tmpchar;
    	if (nuapp_datas.password)
		g_free(nuapp_datas.password);

	/* user_entry */
	tmpchar = g_strdup (gtk_entry_get_text(
                (GtkEntry*)
                lookup_widget((GtkWidget*)button,"username")
                    )
				);
	nuapp_datas.username=tmpchar;


	nuapp_datas.password = g_strdup (gtk_entry_get_text(
                (GtkEntry*)
                lookup_widget((GtkWidget*)button,"password")
                ));

	start_auth(nuapp_datas);

    gtk_widget_destroy(lookup_widget((GtkWidget*)button,"prompt_creds"));

}


void
on_cancelbutton_creds_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(lookup_widget((GtkWidget*)button,"prompt_creds"));
}


void
on_prefs_show                          (GtkWidget       *widget,
                                        gpointer         user_data)
{
  if (nuapp_datas.username) {
      gtk_entry_set_text(
              (GtkEntry*)
              lookup_widget(widget,"pref_username"),
              nuapp_datas.username
              );
  }
 if (nuapp_datas.host) {
      gtk_entry_set_text(
              (GtkEntry*)
              lookup_widget(widget,"pref_host"),
              nuapp_datas.host
              );
  }
 if (nuapp_datas.start_minimized){
	 gtk_toggle_button_set_active(
			 GTK_TOGGLE_BUTTON(
				 lookup_widget(widget,"pref_auth_at_start")), TRUE
			 );
 }
 if (nuapp_datas.auth_at_start){
	 gtk_toggle_button_set_active(
			 GTK_TOGGLE_BUTTON(
				 lookup_widget(widget,"pref_auth_at_start")),TRUE
			 );
 }
 gtk_spin_button_set_value(	 GTK_SPIN_BUTTON(
				 lookup_widget(widget,"pref_port")),nuapp_datas.port);

 gtk_spin_button_set_value(	 GTK_SPIN_BUTTON(
				 lookup_widget(widget,"pref_interval")),nuapp_datas.interval);

}



void
on_creds_realize                       (GtkWidget       *widget,
                                        gpointer         user_data)
{
  if (nuapp_datas.username) {
      gtk_entry_set_text(
              (GtkEntry*)
              lookup_widget(widget,"username"),
              nuapp_datas.username
              );
      /* give focus to password */
      gtk_widget_grab_focus (
              lookup_widget(widget,"password")
              );
  }


}


void
on_password_activate                   (GtkEntry        *entry,
                                        gpointer         user_data)
{
	on_okcreds_clicked                     (GTK_BUTTON(lookup_widget(GTK_WIDGET(entry),"okbutton3")),
        	user_data);

}

